Index: uspace/srv/fs/exfat/exfat_ops.c
===================================================================
--- uspace/srv/fs/exfat/exfat_ops.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/exfat/exfat_ops.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -595,4 +595,7 @@
 int exfat_node_put(fs_node_t *fn)
 {
+	if (fn == NULL)
+		return EOK;
+
 	exfat_node_t *nodep = EXFAT_NODE(fn);
 	bool destroy = false;
@@ -932,5 +935,5 @@
 int exfat_free_block_count(service_id_t service_id, uint64_t *count)
 {
-	fs_node_t *node;
+	fs_node_t *node = NULL;
 	exfat_node_t *bmap_node;
 	exfat_bs_t *bs;
@@ -945,5 +948,4 @@
 
 	bs = block_bb_get(service_id);
-	node = NULL;
 	rc = exfat_bitmap_get(&node, service_id);
 	if (rc != EOK)
@@ -1013,4 +1015,218 @@
 };
 
+static int exfat_fs_open(service_id_t service_id, enum cache_mode cmode,
+    fs_node_t **rrfn, exfat_idx_t **rridxp, vfs_fs_probe_info_t *info)
+{
+	int rc;
+	exfat_node_t *rootp = NULL, *bitmapp = NULL, *uctablep = NULL;
+	exfat_bs_t *bs;
+
+	/* initialize libblock */
+	rc = block_init(service_id, BS_SIZE);
+	if (rc != EOK)
+		return rc;
+
+	/* prepare the boot block */
+	rc = block_bb_read(service_id, BS_BLOCK);
+	if (rc != EOK) {
+		block_fini(service_id);
+		return rc;
+	}
+
+	/* get the buffer with the boot sector */
+	bs = block_bb_get(service_id);
+
+	/* Do some simple sanity checks on the file system. */
+	rc = exfat_sanity_check(bs);
+	if (rc != EOK) {
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		return rc;
+	}
+
+	/* Initialize the block cache */
+	rc = block_cache_init(service_id, BPS(bs), 0 /* XXX */, cmode);
+	if (rc != EOK) {
+		block_fini(service_id);
+		return rc;
+	}
+
+	rc = exfat_idx_init_by_service_id(service_id);
+	if (rc != EOK) {
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		return rc;
+	}
+
+	/* Initialize the root node. */
+	rc = exfat_node_get_new_by_pos(&rootp, service_id, EXFAT_ROOT_PAR, 
+	    EXFAT_ROOT_POS);
+	if (rc!=EOK) {
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOMEM;
+	}
+	assert(rootp->idx->index == EXFAT_ROOT_IDX);
+
+	rootp->type = EXFAT_DIRECTORY;
+	rootp->firstc = ROOT_FC(bs);
+	rootp->fragmented = true;
+	rootp->refcnt = 1;
+	rootp->lnkcnt = 0;	/* FS root is not linked */
+
+	uint32_t clusters;
+	rc = exfat_clusters_get(&clusters, bs, service_id, rootp->firstc);
+	if (rc != EOK) {
+		free(rootp);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOTSUP;
+	}
+	rootp->size = BPS(bs) * SPC(bs) * clusters;
+	fibril_mutex_unlock(&rootp->idx->lock);
+
+	/* Open root directory and looking for Bitmap and UC-Table */
+	exfat_directory_t di;
+	exfat_dentry_t *de;
+	rc = exfat_directory_open(rootp, &di);
+	if (rc != EOK) {
+		free(rootp);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOTSUP;
+	}
+
+	/* Initialize the bitmap node. */
+	rc = exfat_directory_find(&di, EXFAT_DENTRY_BITMAP, &de);
+	if (rc != EOK) {
+		free(rootp);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOTSUP;
+	}
+
+	rc = exfat_node_get_new_by_pos(&bitmapp, service_id, rootp->firstc, 
+	    di.pos);
+	if (rc != EOK) {
+		free(rootp);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOMEM;
+	}
+	assert(bitmapp->idx->index == EXFAT_BITMAP_IDX);
+	fibril_mutex_unlock(&bitmapp->idx->lock);
+
+	bitmapp->type = EXFAT_BITMAP;
+	bitmapp->firstc = uint32_t_le2host(de->bitmap.firstc);
+	bitmapp->fragmented = true;
+	bitmapp->idx->parent_fragmented = true;
+	bitmapp->refcnt = 1;
+	bitmapp->lnkcnt = 0;
+	bitmapp->size = uint64_t_le2host(de->bitmap.size);
+
+	/* Initialize the uctable node. */
+	rc = exfat_directory_seek(&di, 0);
+	if (rc != EOK) {
+		free(rootp);
+		free(bitmapp);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOTSUP;
+	}
+
+	rc = exfat_directory_find(&di, EXFAT_DENTRY_UCTABLE, &de);
+	if (rc != EOK) {
+		free(rootp);
+		free(bitmapp);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOTSUP;
+	}
+
+	rc = exfat_node_get_new_by_pos(&uctablep, service_id, rootp->firstc, 
+	    di.pos);
+	if (rc != EOK) {
+		free(rootp);
+		free(bitmapp);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOMEM;
+	}
+	assert(uctablep->idx->index == EXFAT_UCTABLE_IDX);
+	fibril_mutex_unlock(&uctablep->idx->lock);
+
+	uctablep->type = EXFAT_UCTABLE;
+	uctablep->firstc = uint32_t_le2host(de->uctable.firstc);
+	uctablep->fragmented = true;
+	uctablep->idx->parent_fragmented = true;
+	uctablep->refcnt = 1;
+	uctablep->lnkcnt = 0;
+	uctablep->size = uint64_t_le2host(de->uctable.size);
+
+	if (info != NULL) {
+		/* Read volume label. */
+		rc = exfat_directory_read_vollabel(&di, info->label,
+		    FS_LABEL_MAXLEN + 1);
+		if (rc != EOK) {
+			free(rootp);
+			free(bitmapp);
+			free(uctablep);
+			(void) block_cache_fini(service_id);
+			block_fini(service_id);
+			exfat_idx_fini_by_service_id(service_id);
+    		    return ENOTSUP;
+		}
+	}
+
+	rc = exfat_directory_close(&di);
+	if (rc != EOK) {
+		free(rootp);
+		free(bitmapp);
+		free(uctablep);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		exfat_idx_fini_by_service_id(service_id);
+		return ENOMEM;
+	}
+
+	/* exfat_fsinfo(bs, service_id); */
+
+	*rrfn = FS_NODE(rootp);
+	*rridxp = rootp->idx;
+
+	if (info != NULL) {
+//		str_cpy(info->label, FS_LABEL_MAXLEN + 1, label);
+	}
+
+	return EOK;
+}
+
+static void exfat_fs_close(service_id_t service_id, fs_node_t *rfn)
+{
+	/*
+	 * Put the root node and force it to the FAT free node list.
+	 */
+	(void) exfat_node_put(rfn);
+	(void) exfat_node_put(rfn);
+
+	/*
+	 * Perform cleanup of the node structures, index structures and
+	 * associated data. Write back this file system's dirty blocks and
+	 * stop using libblock for this instance.
+	 */
+	(void) exfat_node_fini_by_service_id(service_id);
+	exfat_idx_fini_by_service_id(service_id);
+	(void) block_cache_fini(service_id);
+	block_fini(service_id);
+}
+
 
 /*
@@ -1054,27 +1270,13 @@
 {
 	int rc;
-	exfat_bs_t *bs;
-
-	/* initialize libblock */
-	rc = block_init(service_id, BS_SIZE);
-	if (rc != EOK)
-		return rc;
-
-	/* prepare the boot block */
-	rc = block_bb_read(service_id, BS_BLOCK);
-	if (rc != EOK) {
-		block_fini(service_id);
-		return rc;
-	}
-
-	/* get the buffer with the boot sector */
-	bs = block_bb_get(service_id);
-
-	/* Do some simple sanity checks on the file system. */
-	rc = exfat_sanity_check(bs);
-
-	(void) block_cache_fini(service_id);
-	block_fini(service_id);
-	return rc;
+	exfat_idx_t *ridxp;
+	fs_node_t *rfn;
+
+	rc = exfat_fs_open(service_id, CACHE_MODE_WT, &rfn, &ridxp, info);
+	if (rc != EOK)
+		return rc;
+
+	exfat_fs_close(service_id, rfn);
+	return EOK;
 }
 
@@ -1084,7 +1286,7 @@
 {
 	int rc;
-	exfat_node_t *rootp = NULL, *bitmapp = NULL, *uctablep = NULL;
 	enum cache_mode cmode;
-	exfat_bs_t *bs;
+	exfat_idx_t *ridxp;
+	fs_node_t *rfn;
 
 	/* Check for option enabling write through. */
@@ -1094,170 +1296,11 @@
 		cmode = CACHE_MODE_WB;
 
-	/* initialize libblock */
-	rc = block_init(service_id, BS_SIZE);
-	if (rc != EOK)
-		return rc;
-
-	/* prepare the boot block */
-	rc = block_bb_read(service_id, BS_BLOCK);
-	if (rc != EOK) {
-		block_fini(service_id);
-		return rc;
-	}
-
-	/* get the buffer with the boot sector */
-	bs = block_bb_get(service_id);
-
-	/* Do some simple sanity checks on the file system. */
-	rc = exfat_sanity_check(bs);
-	if (rc != EOK) {
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		return rc;
-	}
-
-	/* Initialize the block cache */
-	rc = block_cache_init(service_id, BPS(bs), 0 /* XXX */, cmode);
-	if (rc != EOK) {
-		block_fini(service_id);
-		return rc;
-	}
-
-	rc = exfat_idx_init_by_service_id(service_id);
-	if (rc != EOK) {
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		return rc;
-	}
-
-	/* Initialize the root node. */
-	rc = exfat_node_get_new_by_pos(&rootp, service_id, EXFAT_ROOT_PAR, 
-	    EXFAT_ROOT_POS);
-	if (rc!=EOK) {
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOMEM;
-	}
-	assert(rootp->idx->index == EXFAT_ROOT_IDX);
-
-	rootp->type = EXFAT_DIRECTORY;
-	rootp->firstc = ROOT_FC(bs);
-	rootp->fragmented = true;
-	rootp->refcnt = 1;
-	rootp->lnkcnt = 0;	/* FS root is not linked */
-
-	uint32_t clusters;
-	rc = exfat_clusters_get(&clusters, bs, service_id, rootp->firstc);
-	if (rc != EOK) {
-		free(rootp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOTSUP;
-	}
-	rootp->size = BPS(bs) * SPC(bs) * clusters;
-	fibril_mutex_unlock(&rootp->idx->lock);
-
-	/* Open root directory and looking for Bitmap and UC-Table */
-	exfat_directory_t di;
-	exfat_dentry_t *de;
-	rc = exfat_directory_open(rootp, &di);
-	if (rc != EOK) {
-		free(rootp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOTSUP;
-	}
-
-	/* Initialize the bitmap node. */
-	rc = exfat_directory_find(&di, EXFAT_DENTRY_BITMAP, &de);
-	if (rc != EOK) {
-		free(rootp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOTSUP;
-	}
-
-	rc = exfat_node_get_new_by_pos(&bitmapp, service_id, rootp->firstc, 
-	    di.pos);
-	if (rc != EOK) {
-		free(rootp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOMEM;
-	}
-	assert(bitmapp->idx->index == EXFAT_BITMAP_IDX);
-	fibril_mutex_unlock(&bitmapp->idx->lock);
-
-	bitmapp->type = EXFAT_BITMAP;
-	bitmapp->firstc = uint32_t_le2host(de->bitmap.firstc);
-	bitmapp->fragmented = true;
-	bitmapp->idx->parent_fragmented = true;
-	bitmapp->refcnt = 1;
-	bitmapp->lnkcnt = 0;
-	bitmapp->size = uint64_t_le2host(de->bitmap.size);
-
-	/* Initialize the uctable node. */
-	rc = exfat_directory_seek(&di, 0);
-	if (rc != EOK) {
-		free(rootp);
-		free(bitmapp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOTSUP;
-	}
-
-	rc = exfat_directory_find(&di, EXFAT_DENTRY_UCTABLE, &de);
-	if (rc != EOK) {
-		free(rootp);
-		free(bitmapp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOTSUP;
-	}
-
-	rc = exfat_node_get_new_by_pos(&uctablep, service_id, rootp->firstc, 
-	    di.pos);
-	if (rc != EOK) {
-		free(rootp);
-		free(bitmapp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOMEM;
-	}
-	assert(uctablep->idx->index == EXFAT_UCTABLE_IDX);
-	fibril_mutex_unlock(&uctablep->idx->lock);
-
-	uctablep->type = EXFAT_UCTABLE;
-	uctablep->firstc = uint32_t_le2host(de->uctable.firstc);
-	uctablep->fragmented = true;
-	uctablep->idx->parent_fragmented = true;
-	uctablep->refcnt = 1;
-	uctablep->lnkcnt = 0;
-	uctablep->size = uint64_t_le2host(de->uctable.size);
-
-	rc = exfat_directory_close(&di);
-	if (rc != EOK) {
-		free(rootp);
-		free(bitmapp);
-		free(uctablep);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		exfat_idx_fini_by_service_id(service_id);
-		return ENOMEM;
-	}
-
-	/* exfat_fsinfo(bs, service_id); */
-
-	*index = rootp->idx->index;
-	*size = rootp->size;
-	
+	rc = exfat_fs_open(service_id, cmode, &rfn, &ridxp, NULL);
+	if (rc != EOK)
+		return rc;
+
+	*index = ridxp->index;
+	*size = EXFAT_NODE(rfn)->size;
+
 	return EOK;
 }
@@ -1265,38 +1308,12 @@
 static int exfat_unmounted(service_id_t service_id)
 {
-	fs_node_t *fn;
-	exfat_node_t *nodep;
-	int rc;
-
-	rc = exfat_root_get(&fn, service_id);
-	if (rc != EOK)
-		return rc;
-	nodep = EXFAT_NODE(fn);
-
-	/*
-	 * We expect exactly two references on the root node. One for the
-	 * fat_root_get() above and one created in fat_mounted().
-	 */
-	if (nodep->refcnt != 2) {
-		(void) exfat_node_put(fn);
-		return EBUSY;
-	}
-
-	/*
-	 * Put the root node and force it to the FAT free node list.
-	 */
-	(void) exfat_node_put(fn);
-	(void) exfat_node_put(fn);
-
-	/*
-	 * Perform cleanup of the node structures, index structures and
-	 * associated data. Write back this file system's dirty blocks and
-	 * stop using libblock for this instance.
-	 */
-	(void) exfat_node_fini_by_service_id(service_id);
-	exfat_idx_fini_by_service_id(service_id);
-	(void) block_cache_fini(service_id);
-	block_fini(service_id);
-
+	fs_node_t *rfn;
+	int rc;
+
+	rc = exfat_root_get(&rfn, service_id);
+	if (rc != EOK)
+		return rc;
+
+	exfat_fs_close(service_id, rfn);
 	return EOK;
 }
@@ -1363,5 +1380,5 @@
 			return ENOTSUP;
 		}
-			
+
 		aoff64_t spos = pos;
 		char name[EXFAT_FILENAME_LEN + 1];
Index: uspace/srv/fs/fat/fat.h
===================================================================
--- uspace/srv/fs/fat/fat.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/fat/fat.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -136,5 +136,5 @@
 			/** Signature. */
 			uint16_t	signature;
-		} fat32 __attribute__ ((packed));
+		} __attribute__ ((packed)) fat32;
 	};
 } __attribute__ ((packed)) fat_bs_t;
Index: uspace/srv/fs/fat/fat_dentry.c
===================================================================
--- uspace/srv/fs/fat/fat_dentry.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/fat/fat_dentry.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -180,4 +180,33 @@
 }
 
+void fat_dentry_vollabel_get(const fat_dentry_t *d, char *buf)
+{
+	unsigned int i;
+	
+	for (i = 0; i < FAT_NAME_LEN; i++) {
+		if (d->name[i] == FAT_PAD)
+			break;
+		
+		if (d->name[i] == FAT_DENTRY_E5_ESC)
+			*buf++ = 0xe5;
+		else
+			*buf++ = d->name[i];
+	}
+	
+	for (i = 0; i < FAT_EXT_LEN; i++) {
+		if (d->ext[i] == FAT_PAD) {
+			*buf = '\0';
+			return;
+		}
+		
+		if (d->ext[i] == FAT_DENTRY_E5_ESC)
+			*buf++ = 0xe5;
+		else
+			*buf++ = d->ext[i];
+	}
+	
+	*buf = '\0';
+}
+
 fat_dentry_clsf_t fat_classify_dentry(const fat_dentry_t *d)
 {
@@ -191,5 +220,5 @@
 	if (d->attr & FAT_ATTR_VOLLABEL) {
 		/* volume label entry */
-		return FAT_DENTRY_SKIP;
+		return FAT_DENTRY_VOLLABEL;
 	}
 	if (d->name[0] == FAT_DENTRY_ERASED) {
@@ -398,14 +427,4 @@
 }
 
-size_t utf16_length(const uint16_t *wstr)
-{
-	size_t len = 0;
-	
-	while (*wstr++ != 0)
-		len++;
-	
-	return len;
-}
-
 /**
  * @}
Index: uspace/srv/fs/fat/fat_dentry.h
===================================================================
--- uspace/srv/fs/fat/fat_dentry.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/fat/fat_dentry.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,7 +35,9 @@
 #define FAT_FAT_DENTRY_H_
 
+#include <ctype.h>
 #include <stdint.h>
 #include <stdbool.h>
-#include <sys/types.h>
+#include <stddef.h>
+#include <unaligned.h>
 
 #define IS_D_CHAR(ch) (isalnum(ch) || ch == '_')
@@ -44,4 +46,5 @@
 #define FAT_NAME_LEN		8
 #define FAT_EXT_LEN		3
+#define FAT_VOLLABEL_LEN	11
 
 #define FAT_NAME_DOT		".       "
@@ -97,5 +100,6 @@
 	FAT_DENTRY_FREE,
 	FAT_DENTRY_VALID,
-	FAT_DENTRY_LFN
+	FAT_DENTRY_LFN,
+	FAT_DENTRY_VOLLABEL
 } fat_dentry_clsf_t;
 
@@ -137,4 +141,5 @@
 extern void fat_dentry_name_get(const fat_dentry_t *, char *);
 extern void fat_dentry_name_set(fat_dentry_t *, const char *);
+extern void fat_dentry_vollabel_get(const fat_dentry_t *, char *);
 extern fat_dentry_clsf_t fat_classify_dentry(const fat_dentry_t *);
 extern uint8_t fat_dentry_chksum(uint8_t *);
@@ -147,5 +152,4 @@
 
 extern void str_to_ascii(char *, const char *, size_t, uint8_t);
-extern size_t utf16_length(const uint16_t *);
 
 extern bool fat_valid_name(const char *);
Index: uspace/srv/fs/fat/fat_directory.c
===================================================================
--- uspace/srv/fs/fat/fat_directory.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/fat/fat_directory.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -223,7 +223,8 @@
 			*de = d;
 			return EOK;
-		default:
 		case FAT_DENTRY_SKIP:
 		case FAT_DENTRY_FREE:
+		case FAT_DENTRY_VOLLABEL:
+		default:
 			long_entry_count = 0;
 			long_entry = false;
@@ -252,5 +253,5 @@
 	while (!flag && fat_directory_prev(di) == EOK) {
 		if (fat_directory_get(di, &d) == EOK &&
-		    fat_classify_dentry(d) == FAT_DENTRY_LFN &&			
+		    fat_classify_dentry(d) == FAT_DENTRY_LFN &&	
 		    checksum == FAT_LFN_CHKSUM(d)) {
 			if (FAT_IS_LFN(d))
@@ -300,5 +301,5 @@
 			return rc;
 		
-		lfn_size = utf16_length(wname);
+		lfn_size = utf16_wsize(wname);
 		long_entry_count = lfn_size / FAT_LFN_ENTRY_SIZE;
 		if (lfn_size % FAT_LFN_ENTRY_SIZE)
@@ -473,4 +474,5 @@
 			case FAT_DENTRY_LFN:
 			case FAT_DENTRY_SKIP:
+			case FAT_DENTRY_VOLLABEL:
 			default:
 				found = 0;
@@ -523,10 +525,39 @@
 		case FAT_DENTRY_LFN:
 		case FAT_DENTRY_SKIP:
+		case FAT_DENTRY_VOLLABEL:
 		case FAT_DENTRY_FREE:
 			break;
 		}
-	} while (fat_directory_next(di) == EOK);	
+	} while (fat_directory_next(di) == EOK);
 
 	return false;
+}
+
+/** Find volume label entry in a directory.
+ *
+ * @return EOK on success, ENOENT if not found, EIO on I/O error
+ */
+int fat_directory_vollabel_get(fat_directory_t *di, char *label)
+{
+	fat_dentry_t *d;
+	int rc;
+
+	fat_directory_seek(di, 0);
+	do {
+		rc = fat_directory_get(di, &d);
+		if (rc != EOK)
+			return EIO;
+
+		switch (fat_classify_dentry(d)) {
+		case FAT_DENTRY_VOLLABEL:
+			fat_dentry_vollabel_get(d, label);
+			return EOK;
+		default:
+			break;
+		}
+	} while (fat_directory_next(di) == EOK);
+
+	/* Not found */
+	return ENOENT;
 }
 
Index: uspace/srv/fs/fat/fat_directory.h
===================================================================
--- uspace/srv/fs/fat/fat_directory.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/fat/fat_directory.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -72,4 +72,5 @@
     const char *);
 extern int fat_directory_expand(fat_directory_t *);
+extern int fat_directory_vollabel_get(fat_directory_t *, char *);
 
 #endif
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/fat/fat_ops.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -785,4 +785,5 @@
 			case FAT_DENTRY_SKIP:
 			case FAT_DENTRY_FREE:
+			case FAT_DENTRY_VOLLABEL:
 				continue;
 			case FAT_DENTRY_LAST:
@@ -909,9 +910,6 @@
 };
 
-/*
- * FAT VFS_OUT operations.
- */
-
-static int fat_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
+static int fat_fs_open(service_id_t service_id, enum cache_mode cmode,
+    fs_node_t **rrfn, fat_idx_t **rridxp)
 {
 	fat_bs_t *bs;
@@ -939,5 +937,5 @@
 
 	/* Initialize the block cache */
-	rc = block_cache_init(service_id, BPS(bs), 0 /* XXX */, CACHE_MODE_WB);
+	rc = block_cache_init(service_id, BPS(bs), 0 /* XXX */, cmode);
 	if (rc != EOK) {
 		block_fini(service_id);
@@ -947,9 +945,133 @@
 	/* Do some simple sanity checks on the file system. */
 	rc = fat_sanity_check(bs, service_id);
-
+	if (rc != EOK) {
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		return rc;
+	}
+
+	rc = fat_idx_init_by_service_id(service_id);
+	if (rc != EOK) {
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		return rc;
+	}
+
+	/* Initialize the root node. */
+	fs_node_t *rfn = (fs_node_t *)malloc(sizeof(fs_node_t));
+	if (!rfn) {
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		fat_idx_fini_by_service_id(service_id);
+		return ENOMEM;
+	}
+
+	fs_node_initialize(rfn);
+	fat_node_t *rootp = (fat_node_t *)malloc(sizeof(fat_node_t));
+	if (!rootp) {
+		free(rfn);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		fat_idx_fini_by_service_id(service_id);
+		return ENOMEM;
+	}
+	fat_node_initialize(rootp);
+
+	fat_idx_t *ridxp = fat_idx_get_by_pos(service_id, FAT_CLST_ROOTPAR, 0);
+	if (!ridxp) {
+		free(rfn);
+		free(rootp);
+		(void) block_cache_fini(service_id);
+		block_fini(service_id);
+		fat_idx_fini_by_service_id(service_id);
+		return ENOMEM;
+	}
+	assert(ridxp->index == 0);
+	/* ridxp->lock held */
+
+	rootp->type = FAT_DIRECTORY;
+	rootp->firstc = FAT_ROOT_CLST(bs);
+	rootp->refcnt = 1;
+	rootp->lnkcnt = 0;	/* FS root is not linked */
+
+	if (FAT_IS_FAT32(bs)) {
+		uint32_t clusters;
+		rc = fat_clusters_get(&clusters, bs, service_id, rootp->firstc);
+		if (rc != EOK) {
+			fibril_mutex_unlock(&ridxp->lock);
+			free(rfn);
+			free(rootp);
+			(void) block_cache_fini(service_id);
+			block_fini(service_id);
+			fat_idx_fini_by_service_id(service_id);
+			return ENOTSUP;
+		}
+		rootp->size = BPS(bs) * SPC(bs) * clusters;
+	} else
+		rootp->size = RDE(bs) * sizeof(fat_dentry_t);
+
+	rootp->idx = ridxp;
+	ridxp->nodep = rootp;
+	rootp->bp = rfn;
+	rfn->data = rootp;
+
+	fibril_mutex_unlock(&ridxp->lock);
+
+	*rrfn = rfn;
+	*rridxp = ridxp;
+
+	return EOK;
+}
+
+static void fat_fs_close(service_id_t service_id, fs_node_t *rfn)
+{
+	free(rfn->data);
+	free(rfn);
 	(void) block_cache_fini(service_id);
 	block_fini(service_id);
-
-	return rc;
+	fat_idx_fini_by_service_id(service_id);
+}
+
+/*
+ * FAT VFS_OUT operations.
+ */
+
+static int fat_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
+{
+	fat_idx_t *ridxp;
+	fs_node_t *rfn;
+	fat_node_t *nodep;
+	fat_directory_t di;
+	char label[FAT_VOLLABEL_LEN + 1];
+	int rc;
+
+	rc = fat_fs_open(service_id, CACHE_MODE_WT, &rfn, &ridxp);
+	if (rc != EOK)
+		return rc;
+
+	nodep = FAT_NODE(rfn);
+
+	rc = fat_directory_open(nodep, &di);
+	if (rc != EOK) {
+		fat_fs_close(service_id, rfn);
+		return rc;
+	}
+
+	rc = fat_directory_vollabel_get(&di, label);
+	if (rc != EOK) {
+		if (rc != ENOENT) {
+			fat_fs_close(service_id, rfn);
+			return rc;
+		}
+
+		label[0] = '\0';
+	}
+
+	str_cpy(info->label, FS_LABEL_MAXLEN + 1, label);
+
+	fat_directory_close(&di);
+	fat_fs_close(service_id, rfn);
+
+	return EOK;
 }
 
@@ -959,6 +1081,7 @@
 {
 	enum cache_mode cmode = CACHE_MODE_WB;
-	fat_bs_t *bs;
 	fat_instance_t *instance;
+	fat_idx_t *ridxp;
+	fs_node_t *rfn;
 	int rc;
 
@@ -978,6 +1101,5 @@
 	}
 
-	/* initialize libblock */
-	rc = block_init(service_id, BS_SIZE);
+	rc = fat_fs_open(service_id, cmode, &rfn, &ridxp);
 	if (rc != EOK) {
 		free(instance);
@@ -985,124 +1107,18 @@
 	}
 
-	/* prepare the boot block */
-	rc = block_bb_read(service_id, BS_BLOCK);
-	if (rc != EOK) {
-		free(instance);
-		block_fini(service_id);
-		return rc;
-	}
-
-	/* get the buffer with the boot sector */
-	bs = block_bb_get(service_id);
-	
-	if (BPS(bs) != BS_SIZE) {
-		free(instance);
-		block_fini(service_id);
-		return ENOTSUP;
-	}
-
-	/* Initialize the block cache */
-	rc = block_cache_init(service_id, BPS(bs), 0 /* XXX */, cmode);
-	if (rc != EOK) {
-		free(instance);
-		block_fini(service_id);
-		return rc;
-	}
-
-	/* Do some simple sanity checks on the file system. */
-	rc = fat_sanity_check(bs, service_id);
-	if (rc != EOK) {
-		free(instance);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		return rc;
-	}
-
-	rc = fat_idx_init_by_service_id(service_id);
-	if (rc != EOK) {
-		free(instance);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		return rc;
-	}
-
-	/* Initialize the root node. */
-	fs_node_t *rfn = (fs_node_t *)malloc(sizeof(fs_node_t));
-	if (!rfn) {
-		free(instance);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		fat_idx_fini_by_service_id(service_id);
-		return ENOMEM;
-	}
-
-	fs_node_initialize(rfn);
-	fat_node_t *rootp = (fat_node_t *)malloc(sizeof(fat_node_t));
-	if (!rootp) {
-		free(instance);
-		free(rfn);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		fat_idx_fini_by_service_id(service_id);
-		return ENOMEM;
-	}
-	fat_node_initialize(rootp);
-
-	fat_idx_t *ridxp = fat_idx_get_by_pos(service_id, FAT_CLST_ROOTPAR, 0);
-	if (!ridxp) {
-		free(instance);
-		free(rfn);
-		free(rootp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		fat_idx_fini_by_service_id(service_id);
-		return ENOMEM;
-	}
-	assert(ridxp->index == 0);
-	/* ridxp->lock held */
-
-	rootp->type = FAT_DIRECTORY;
-	rootp->firstc = FAT_ROOT_CLST(bs);
-	rootp->refcnt = 1;
-	rootp->lnkcnt = 0;	/* FS root is not linked */
-
-	if (FAT_IS_FAT32(bs)) {
-		uint32_t clusters;
-		rc = fat_clusters_get(&clusters, bs, service_id, rootp->firstc);
-		if (rc != EOK) {
-			fibril_mutex_unlock(&ridxp->lock);
-			free(instance);
-			free(rfn);
-			free(rootp);
-			(void) block_cache_fini(service_id);
-			block_fini(service_id);
-			fat_idx_fini_by_service_id(service_id);
-			return ENOTSUP;
-		}
-		rootp->size = BPS(bs) * SPC(bs) * clusters;
-	} else
-		rootp->size = RDE(bs) * sizeof(fat_dentry_t);
+	fibril_mutex_lock(&ridxp->lock);
 
 	rc = fs_instance_create(service_id, instance);
 	if (rc != EOK) {
 		fibril_mutex_unlock(&ridxp->lock);
+		fat_fs_close(service_id, rfn);
 		free(instance);
-		free(rfn);
-		free(rootp);
-		(void) block_cache_fini(service_id);
-		block_fini(service_id);
-		fat_idx_fini_by_service_id(service_id);
-		return rc;
-	}
-
-	rootp->idx = ridxp;
-	ridxp->nodep = rootp;
-	rootp->bp = rfn;
-	rfn->data = rootp;
+		return rc;
+	}
 
 	fibril_mutex_unlock(&ridxp->lock);
 
 	*index = ridxp->index;
-	*size = rootp->size;
+	*size = FAT_NODE(rfn)->size;
 
 	return EOK;
@@ -1174,5 +1190,4 @@
 	 */
 	(void) fat_node_put(fn);
-	(void) fat_node_put(fn);
 
 	/*
@@ -1182,7 +1197,5 @@
 	 */
 	(void) fat_node_fini_by_service_id(service_id);
-	fat_idx_fini_by_service_id(service_id);
-	(void) block_cache_fini(service_id);
-	block_fini(service_id);
+	fat_fs_close(service_id, fn);
 
 	void *data;
Index: uspace/srv/fs/udf/udf_osta.c
===================================================================
--- uspace/srv/fs/udf/udf_osta.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/udf/udf_osta.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -51,20 +51,4 @@
 #include "udf_osta.h"
 #include "udf_cksum.h"
-
-/** Calculate length of UTF-16 string
- *
- * FIXME: This is wrong! UTF-16 is not a fixed-width encoding,
- *        it is a variable-width encoding (mind the surrogate
- *        pairs).
- *
- */
-static size_t utf16_length(uint16_t *string) {
-	size_t len = 0;
-	
-	while (*string++ != 0)
-		len++;
-	
-	return len;
-}
 
 /** Illegal UNIX characters are NULL and slash.
@@ -296,5 +280,5 @@
 		ucode_chars =
 		    udf_uncompress_unicode(len, (uint8_t *) id, raw_name, MAX_BUF);
-		ucode_chars = min(ucode_chars, utf16_length(raw_name));
+		ucode_chars = min(ucode_chars, utf16_wsize(raw_name));
 		nice_uchars =
 		    udf_translate_name(unix_name, raw_name, ucode_chars);
Index: uspace/srv/hid/input/ctl/kbdev.c
===================================================================
--- uspace/srv/hid/input/ctl/kbdev.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hid/input/ctl/kbdev.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -45,5 +45,4 @@
 #include <stdlib.h>
 #include <vfs/vfs_sess.h>
-#include <sys/typefmt.h>
 #include "../gsp.h"
 #include "../input.h"
Index: uspace/srv/hid/input/port/adb.c
===================================================================
--- uspace/srv/hid/input/port/adb.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hid/input/port/adb.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -62,7 +62,7 @@
 	kbd_dev = kdev;
 	
-	const char *dev = "adb/kbd";
+	const char *dev = "devices/\\hw\\adb\\kbd";
 	service_id_t service_id;
-	int rc = loc_service_get_id(dev, &service_id, 0);
+	int rc = loc_service_get_id(dev, &service_id, IPC_FLAG_BLOCKING);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/hid/input/port/adb_mouse.c
===================================================================
--- uspace/srv/hid/input/port/adb_mouse.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hid/input/port/adb_mouse.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -75,10 +75,10 @@
 static int adb_port_init(mouse_dev_t *mdev)
 {
-	const char *dev = "adb/mouse";
+	const char *dev = "devices/\\hw\\adb\\mouse";
 	
 	mouse_dev = mdev;
 	
 	service_id_t service_id;
-	int rc = loc_service_get_id(dev, &service_id, 0);
+	int rc = loc_service_get_id(dev, &service_id, IPC_FLAG_BLOCKING);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/hid/input/port/msim.c
===================================================================
--- uspace/srv/hid/input/port/msim.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hid/input/port/msim.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -97,6 +97,5 @@
 	msim_ranges[0].base = paddr;
 	msim_cmds[0].addr = (void *) paddr;
-	async_irq_subscribe(inr, device_assign_devno(), msim_irq_handler, NULL,
-	    &msim_kbd);
+	async_irq_subscribe(inr, msim_irq_handler, NULL, &msim_kbd);
 	
 	return 0;
Index: uspace/srv/hid/input/proto/mousedev.c
===================================================================
--- uspace/srv/hid/input/proto/mousedev.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hid/input/proto/mousedev.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,5 +43,4 @@
 #include <ipc/mouseev.h>
 #include <loc.h>
-#include <sys/typefmt.h>
 #include "../mouse.h"
 #include "../mouse_port.h"
Index: uspace/srv/hid/output/proto/vt100.c
===================================================================
--- uspace/srv/hid/output/proto/vt100.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hid/output/proto/vt100.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #include <malloc.h>
 #include <io/color.h>
+#include <types/common.h>
 #include "vt100.h"
 
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -137,6 +137,5 @@
 	    (void *) ts->paddr, inr);
 
-	async_irq_subscribe(inr, device_assign_devno(), s3c24xx_ts_irq_handler,
-	    NULL, &ts_irq_code);
+	async_irq_subscribe(inr, s3c24xx_ts_irq_handler, NULL, &ts_irq_code);
 
 	s3c24xx_ts_wait_for_int_mode(ts, updn_down);
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -193,6 +193,5 @@
 	    (void *) uart->paddr, inr);
 
-	async_irq_subscribe(inr, device_assign_devno(), s3c24xx_uart_irq_handler,
-	    NULL, &uart_irq_code);
+	async_irq_subscribe(inr, s3c24xx_uart_irq_handler, NULL, &uart_irq_code);
 
 	/* Enable FIFO, Tx trigger level: empty, Rx trigger level: 1 byte. */
